"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/date-picker/style");

var _datePicker = _interopRequireDefault(require("antd/lib/date-picker"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _glAntdLocales = _interopRequireDefault(require("@groundline/gl-antd-locales"));

var _reactIntl = require("react-intl");

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _transformFormat = require("./transformFormat");

var _class, _class2, _temp;

var DateTimePicker = (0, _reactIntl.injectIntl)(_class = (_temp = _class2 =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2.default)(DateTimePicker, _PureComponent);

  function DateTimePicker() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, DateTimePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(DateTimePicker)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChange", function (date) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          refId = _this$props.refId,
          _this$props$uiParams = _this$props.uiParams,
          uiParams = _this$props$uiParams === void 0 ? {} : _this$props$uiParams;
      onChange(refId, "update", (0, _transformFormat.transformMomentToString)(date, uiParams.output));
    });
    return _this;
  }

  (0, _createClass2.default)(DateTimePicker, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          value = _this$props2.value,
          _this$props2$uiParams = _this$props2.uiParams,
          uiParams = _this$props2$uiParams === void 0 ? {} : _this$props2$uiParams,
          intl = _this$props2.intl,
          disabled = _this$props2.disabled;
      var date = (0, _transformFormat.transformStringToMoment)(value, uiParams.output);

      if (uiParams.timezone) {
        date = date.tz(uiParams.timezone);
      }

      return _react.default.createElement(_datePicker.default, {
        value: date,
        disabled: disabled,
        format: uiParams && uiParams.format,
        placeholder: intl.formatMessage({
          id: "string.datetimepicker.placeholder",
          defaultMessage: _glAntdLocales.default.en["string.datetimepicker.placeholder"]
        }),
        onChange: this.onChange
      });
    }
  }]);
  return DateTimePicker;
}(_react.PureComponent), (0, _defineProperty2.default)(_class2, "defaultProps", {
  uiParams: {
    format: "YYYY/MM/DD",
    output: "ISO_8601"
  }
}), _temp)) || _class;

exports.default = DateTimePicker;